<?php

namespace Drupal\group_comment_permissions\Plugin\GroupContentEnabler;

use Drupal;
use Drupal\Component\Plugin\Derivative\DeriverBase;
use Drupal\Core\StringTranslation\StringTranslationTrait;

/**
 *
 */
class GroupCommentDeriver extends DeriverBase {

  use StringTranslationTrait;

  /**
   * {@inheritdoc}.
   */
  public function getDerivativeDefinitions($base_definition) {
    foreach (Drupal::service('entity.manager')
      ->getBundleInfo('comment') as $bundle_id => $bundle_info) {
      $this->derivatives[$bundle_id] = [
        'entity_bundle' => $bundle_id,
        'label' => $this->t('Group comment (@bundle)', [
          '@bundle' => $bundle_info['label'],
        ]),
        'description' => $this->t('Manage permissions on @bundle.', [
          '@bundle' => $bundle_info['label'],
        ]),
      ] + $base_definition;
    }

    return $this->derivatives;
  }

}
